Function zerokiller ()
	Window.StatusText "Deleting unnecessarily Zeros", &hE07000
	Document.Range.ReplaceText "0\.0\w+" , "0 ", vpMatchRegExp 
	Document.Range.ReplaceText "0\.00\w+" , "0 ", vpMatchRegExp 
	Document.Range.ReplaceText "0\.000\w+" , "0 ", vpMatchRegExp 
	Document.Range.ReplaceText "0\.0000\w+" , "0 ", vpMatchRegExp 
	Document.Range.ReplaceText "0\.00000\w+" , "0 ", vpMatchRegExp 
	Document.Range.ReplaceText "0\.000000\w+" , "0 ", vpMatchRegExp 
	Document.Range.ReplaceText "0\.000000$" , "0", vpMatchRegExp 
	Document.Range.ReplaceText "\w+\.0\w+" , " 0 ", vpMatchRegExp 
	Document.Range.ReplaceText "\w+\.0$" , " 0", vpMatchRegExp 
	Document.Range.ReplaceText "\w+0\.$" , " 0", vpMatchRegExp 
	Document.Range.ReplaceText "\w+0\.\w+" , " 0 ", vpMatchRegExp 
	Document.Range.ReplaceText "\w+0\.0\w+" , " 0 ", vpMatchRegExp 
	Document.Range.ReplaceText "\w+0\.0$" , " 0", vpMatchRegExp 
	Document.Range.ReplaceText "\w+\.00000e\+0" , " 0", vpMatchRegExp
	Document.Range.ReplaceText "\.000000\w+" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "\.00000\w+" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "\.0000\w+" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "\.000\w+" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "\.00\w+" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "\.0\w+" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "\.000000," , " ", vpMatchRegExp 
	Document.Range.ReplaceText "\.00000," , " ", vpMatchRegExp 
	Document.Range.ReplaceText "\.0000," , " ", vpMatchRegExp 
	Document.Range.ReplaceText "\.000," , " ", vpMatchRegExp 
	Document.Range.ReplaceText "\.00," , " ", vpMatchRegExp 
	Document.Range.ReplaceText "\.0," , " ", vpMatchRegExp 
	Document.Range.ReplaceText "\.0$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "\.00$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "\.000$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "\.0000$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "\.00000$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "\.000000$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "\w+000000" , " 0", vpMatchRegExp 
	Document.Range.ReplaceText "\w+00000" , " 0", vpMatchRegExp 
	Document.Range.ReplaceText "\w+0000" , " 0", vpMatchRegExp 
	Document.Range.ReplaceText "\w+000" , " 0", vpMatchRegExp 
	Document.Range.ReplaceText "\w+00" , " 0", vpMatchRegExp 
	Document.Range.ReplaceText "\w+0\." , " .", vpMatchRegExp 
	Document.Range.ReplaceText "-0\." , "-.", vpMatchRegExp 
End Function

Function comkiller()
Window.StatusText "Deleting Comments", &hE07000
	Document.Range.ReplaceText "^#.*" , "", vpMatchRegExp 
	Document.Range.ReplaceText "#\w+.*" , "", vpMatchRegExp 
	Document.Range.ReplaceText "\w+#.*" , "", vpMatchRegExp 
	Document.Range.ReplaceText "^//.*" , "", vpMatchRegExp 
	Document.Range.ReplaceText "//\w+.*" , "", vpMatchRegExp 
End Function

Function defkiller()
	Dim Node
	Window.StatusText "Deleting unnecessary DEFinitions", &hE07000
	For Each Node In Document.Nodes
  		If Node.References.Count = 0 And _
  			Node.InRoutes.Count = 0 And _
    		Node.OutRoutes.Count = 0 Then Node.Name = ""
    		cc = cc + 1
	Next
End Function

BindCommand "CMDsc", "Optimize the Code for small file size", "Commands|Code|Optimize Code","Alt+O"

Sub CMDsc
	set rng=Document.Range.End
	cc = 0
	
	defkiller()
	
	Document.Range.ReplaceText "#VRML V2.0 utf8" , "VVRML V2.0 utf8", vpMatchRegExp 
	
	Window.StatusText "Unindenting the Code", &hE07000
	Document.Range.Unindent (30)
	
	zerokiller()
	
	comkiller()	
	
	Window.StatusText "Unindenting the Code again", &hE07000
	Document.Range.Unindent (10)
	
	Window.StatusText "Collapsing Lines", &hE07000
	Document.Range.ReplaceText "\w+\[" , "[", vpMatchRegExp 
	Document.Range.ReplaceText "\[\w+" , "[", vpMatchRegExp 
	Document.Range.ReplaceText "\w+\]" , "]", vpMatchRegExp 
	Document.Range.ReplaceText "\]\w+" , "]", vpMatchRegExp 

	BeginOperation "del breaks"
		for yy=Document.Range.ToLine-1 to 1 step -1
    	rng.FromLine=yy
     	rng.ToLine=yy
     	rng.FromRow=1
     	rng.ToRow=-1
			if right(rng.Text,1)="["then
				rng.FromRow=-1
				rng.ToLine=yy+1
				rng.ToRow=1
				rng.Delete
				cc = cc + 1
			elseif left(rng.Text,1)="]"then
				rng.FromLine=yy-1
				rng.FromRow=-1
				rng.ToLine=yy
				rng.ToRow=1
				rng.Delete
				cc = cc + 1
			elseif left(rng.Text,1)="["then
				rng.FromLine=yy-1
				rng.FromRow=-1
				rng.ToLine=yy
				rng.ToRow=1
				rng.Delete
				cc = cc + 1
			elseif left(rng.Text,1)=""then
				rng.FromLine=yy
				rng.FromRow=0
				rng.ToLine=yy+1
				rng.ToRow=0
				rng.Delete
				cc = cc + 1
			elseif left(rng.Text,1)="\w+"then
				rng.FromLine=yy
				rng.FromRow=0
				rng.ToLine=yy+1
				rng.ToRow=0
				rng.Delete
				cc = cc + 1
			end if
		next
	EndOperation
	
	Document.Range.ReplaceText "\[" , " [ ", vpMatchRegExp 
	Document.Range.ReplaceText "\]" , " ] ", vpMatchRegExp 
	
	zerokiller()
	
	Document.Range.ReplaceText "VVRML V2 utf8" , "#VRML V2.0 utf8", vpMatchRegExp 
	
	Window.StatusText "Unindenting the Code again", &hE07000
	Document.Range.Unindent (10)
	
	cc = CStr(cc)
	MsgBox "Unnecessarily zeros and comments were deleted, making " + cc + " Changes",0,"Optimize File"

end sub

BindCommand "CMDsck", "Optimize the Code for small file size, but keeping comments and DEFs", "Commands|Code|Optimize Code, keeping comments and DEFs","Alt+K"

Sub CMDsck
	set rng=Document.Range.End
	cc = 0
	
	Document.Range.ReplaceText "#VRML V2.0 utf8" , "VVRML V2.0 utf8", vpMatchRegExp 
	
	Window.StatusText "Unindenting the Code", &hE07000
	Document.Range.Unindent (10)
	
	zerokiller()
	
	Window.StatusText "Unindenting the Code again", &hE07000
	Document.Range.Unindent (10)
	
	Window.StatusText "Collapsing Lines", &hE07000
	Document.Range.ReplaceText "\w+\[" , "[", vpMatchRegExp 
	Document.Range.ReplaceText "\[\w+" , "[", vpMatchRegExp 
	Document.Range.ReplaceText "\w+\]" , "]", vpMatchRegExp 
	Document.Range.ReplaceText "\]\w+" , "]", vpMatchRegExp 

	BeginOperation "del breaks"
		for yy=Document.Range.ToLine-1 to 1 step -1
    	rng.FromLine=yy
     	rng.ToLine=yy
     	rng.FromRow=1
     	rng.ToRow=-1
			if right(rng.Text,1)="["then
				rng.FromRow=-1
				rng.ToLine=yy+1
				rng.ToRow=1
				rng.Delete
				cc = cc + 1
			elseif left(rng.Text,1)="]"then
				rng.FromLine=yy-1
				rng.FromRow=-1
				rng.ToLine=yy
				rng.ToRow=1
				rng.Delete
				cc = cc + 1
			elseif left(rng.Text,1)="["then
				rng.FromLine=yy-1
				rng.FromRow=-1
				rng.ToLine=yy
				rng.ToRow=1
				rng.Delete
				cc = cc + 1
			elseif left(rng.Text,1)=""then
				rng.FromLine=yy
				rng.FromRow=0
				rng.ToLine=yy+1
				rng.ToRow=0
				rng.Delete
				cc = cc + 1
			elseif left(rng.Text,1)="\w+"then
				rng.FromLine=yy
				rng.FromRow=0
				rng.ToLine=yy+1
				rng.ToRow=0
				rng.Delete
				cc = cc + 1
			end if
		next
	EndOperation
	
	Document.Range.ReplaceText "\[" , " [ ", vpMatchRegExp 
	Document.Range.ReplaceText "\]" , " ] ", vpMatchRegExp 
	
	zerokiller()
		
	Window.StatusText "Unindenting the Code", &hE07000
	Document.Range.Unindent (10)
	
	Document.Range.ReplaceText "VVRML V2 utf8" , "#VRML V2.0 utf8", vpMatchRegExp 
	
	cc = CStr(cc)
	MsgBox "Unnecessarily zeros and comments were deleted, making " + cc + " Changes",0,"Optimize File"

end sub


BindCommand "CMDrc", "Uses SmartFormat for formating the Code", "Commands|Code|Reformat Code","Alt+R"

Sub CMDrc
	Document.Range.SmartFormat
end sub

BindCommand "CMDuic", "Unindents the complete File", "Commands|Code|Unindent Code","Alt+U"

Sub CMDuic
	Document.Range.Unindent (50)
end sub

BindCommand "CMDc", "Remove any comment in the File", "Commands|Code|Remove Comments","Alt+M"

Sub CMDc
	Document.Range.ReplaceText "#VRML V2.0 utf8" , "VVRML V2.0 utf8", vpMatchRegExp 
	
	comkiller()
	
	Document.Range.ReplaceText "VVRML V2.0 utf8" , "#VRML V2.0 utf8", vpMatchRegExp 
	
	MsgBox "Comments were deleted",0,"Remove Comments"
end Sub

BindCommand "Rem3ds", "3dsMax Cleanup - Deletes unnecessary DEFinitions and TimeSensors", "Commands|Code|3dsMax Cleanup","Alt+X"

Sub Rem3ds
	Dim Node
	
	defkiller()
	
	comkiller()

	Window.StatusText "Deleting useless TimeSensors", &hE07000
	For Each fs In StdProtos("TimeSensor").Instances
		If fs.References.Count = 0 And _
  			fs.InRoutes.Count = 0 And _
    		fs.OutRoutes.Count = 0 Then fs.Delete
    		cc = cc + 1
	Next
	Window.StatusText "Deleting empty Transforms", &hE07000
	For Each fs In StdProtos("Transform").Instances
		If fs.Fields("children").Count = 0 Then fs.Delete
    		cc = cc + 1
	Next
	
	cc = CStr(cc)
	MsgBox cc + " empty Transforms and unsed DEFs/ TimeSensors were deleted.",0,"3dsMax Cleanup"
end Sub

BindCommand "RemDef", "3dsMax Cleanup - Deletes unnecessary DEFinitions and TimeSensors", "Commands|Code|Remove unused DEFs","Alt+V"

Sub RemDef
	Dim Node
	
	defkiller()
		
	cc = CStr(cc)
	MsgBox cc + " unsed DEFs were deleted.",0,"Remove unsed DEFs"
end Sub


BindCommand "RemDefFld", "Remove default field and field values", "Commands|Code|Remove default fields","Alt+D"

Sub RemDefFld
	set rng=Document.Range.End
	Document.Range.ReplaceText "#VRML V2.0 utf8" , "VVRML V2.0 utf8", vpMatchRegExp 
	
	Window.StatusText "Unindenting the Code", &hE07000
	Document.Range.Unindent (30)
	
	zerokiller()
	
	Window.StatusText "Unindenting the Code again", &hE07000
	Document.Range.Unindent (10)
	
	Window.StatusText "Deleting default fields", &hE07000
	Document.Range.ReplaceText "\w+intensity\w+1" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "^intensity\w+1" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "cycleInterval\w+1" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "translation\w+0\w+0\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "scale\w+0\w+0\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "center\w+0\w+0\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "radius\w+100$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "direction\w+0\w+0\w+1" , "", vpMatchRegExp 
	Document.Range.ReplaceText "location\w+0\w+0\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "maxBack\w+10$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "maxFront\w+10$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "maxBack\w+1$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "maxFront\w+1$" , "", vpMatchRegExp 
	
	Document.Range.ReplaceText "translation\w+0\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "bboxCenter\w+0\w+0\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "center\w+0\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "\w+color\w+1\w+1\w+1" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "^color\w+1\w+1\w+1" , "", vpMatchRegExp 
	Document.Range.ReplaceText "emissiveColor\w+0\w+0\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "specularColor\w+0\w+0\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "ambientIntensity\w+.2$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "ambientIntensity\w+.2\w+" , "", vpMatchRegExp 
	Document.Range.ReplaceText "shininess\w+.2\w+" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "shininess\w+.2$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "\w+on\w+TRUE" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "^on\w+TRUE" , "", vpMatchRegExp 
	Document.Range.ReplaceText "attenuation\w+1\w+0\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "\w+transparency\w+0" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "^transparency\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "rotation\w+0$" , " ", vpMatchRegExp 
	Document.Range.ReplaceText "fieldOfView\w+.785398" , "", vpMatchRegExp 
	Document.Range.ReplaceText "beginCap\w+TRUE" , "", vpMatchRegExp 
	Document.Range.ReplaceText "endCap\w+TRUE" , "", vpMatchRegExp 
	Document.Range.ReplaceText "ccw\w+TRUE" , "", vpMatchRegExp 
	Document.Range.ReplaceText "convex\w+TRUE" , "", vpMatchRegExp 
	Document.Range.ReplaceText "solid\w+TRUE" , "", vpMatchRegExp 
	Document.Range.ReplaceText "loop\w+FALSE" , "", vpMatchRegExp 
	Document.Range.ReplaceText "jump\w+TRUE" , "", vpMatchRegExp 
	Document.Range.ReplaceText "headlight\w+TRUE" , "", vpMatchRegExp 
	Document.Range.ReplaceText "stopTime\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "priority\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "creaseAngle\w+0" , "", vpMatchRegExp 
	Document.Range.ReplaceText "whichChoice\w+-1" , "", vpMatchRegExp 
	Document.Range.ReplaceText "speed\w+1$" , "", vpMatchRegExp 
	Document.Range.ReplaceText "speed\w+1\w+" , " ", vpMatchRegExp 
	
	Window.StatusText "Unindenting the Code again", &hE07000
	Document.Range.Unindent (10)
	
	Window.StatusText "Collapsing Lines", &hE07000
	BeginOperation "del breaks"
		for yy=Document.Range.ToLine-1 to 1 step -1
    	rng.FromLine=yy
     	rng.ToLine=yy
     	rng.FromRow=1
     	rng.ToRow=-1
			if left(rng.Text,1)=""then
				rng.FromLine=yy
				rng.FromRow=0
				rng.ToLine=yy+1
				rng.ToRow=0
				rng.Delete
				cc = cc + 1
			elseif left(rng.Text,1)="\w+"then
				rng.FromLine=yy
				rng.FromRow=0
				rng.ToLine=yy+1
				rng.ToRow=0
				rng.Delete
				cc = cc + 1
			end if
		next
	EndOperation
	
	Document.Range.ReplaceText "VVRML V2 utf8" , "#VRML V2.0 utf8", vpMatchRegExp 
	
	Window.StatusText "Formating code using SmartFormat", &hE07000
	Document.Range.SmartFormat
	
	MsgBox "Unnecessarily zeros and default Fields were deleted",0,"Remove default fields"
	
end Sub

BindCommand "CMDeprt", "Inserts the Externproto Definition (If 'Insert node Definition on AutoComplete' at Tools>Options>General>VRML Extensions is checked.", "Commands|Code|Insert Externproto","Alt+P"
BindPopup "CMDeprt", "Insert Externproto", "*"
Sub CMDeprt

Set e = CurrentEntity
If e Is Nothing Then
  MsgBox "There seems to be nothing.",0,"Insert Externproto"
Else
  Select Case e.EntityType
    Case vpNode, vpNodeRef
      nn = e.TypeName
      Set defnn = Document.RootNodes.Add(nn)
      defnn.Name ="PleaseKillMe"
      defnn.Delete
    Case vpField, vpFieldDecl, vpProtoURL
      MsgBox "Sorry, just a Field: " & e.Name,0,"Insert Externproto"
    Case vpProto, vpExternProto
      MsgBox "Sorry, just a Proto: " & e.Name,0,"Insert Externproto"
    Case vpRoute
      MsgBox "Sorry, just a Route from: " & e.FromField.Name,0,"Insert Externproto"
  End Select
End If
End Sub

BindCommand "CMcreDef", "Creates a DEF of the node by using the first 2 characters and the time", "Commands|Code|Create DEFinition","Alt+N"
BindPopup "CMcreDef", "Create DEFinition", "*"
Sub CMcreDef
Set e = CurrentEntity

If e Is Nothing Then
  MsgBox "There seems to be nothing.",0,"Create DEFinition"
Else
	
  Select Case e.EntityType
    Case vpNode
    	Dim MyString, LeftString
    	Dim rgn
    	Dim MySec
    	MySec = Second(Now)
    	MySec = CStr(MySec)
      nn = e.TypeName
      MyString = nn
      LeftString = Left(MyString, 2)
      LeftString = LeftString + MySec
      Set rgn = Document.Range.FindText(LeftString, vpMatchCase + vpMatchWord)
      If rgn Is Nothing Then 
      	e.Name = LeftString 
      Else
      	LeftString = LeftString + "_1"
		End If            
    Case vpNodeRef    
    	MsgBox "Sorry, a Reference from: " & e.Name,0,"Create DEFinition"
    Case vpField, vpFieldDecl, vpProtoURL
      MsgBox "Sorry, just a Field: " & e.Name,0,"Create DEFinition"
    Case vpProto, vpExternProto
      MsgBox "Sorry, just a Proto: " & e.Name,0,"Create DEFinition"
    Case vpRoute
      MsgBox "Sorry, just a Route from: " & e.FromField.Name,0,"Create DEFinition"
  End Select
End If
End Sub

BindCommand "CMcreUse", "Creates USE from a Node, if the node is not DEFinied it will be named", "Commands|Code|Create USE","Alt+A"
BindPopup "CMcreUse", "Create USE", "*"
Sub CMcreUse
Set e = CurrentEntity

If e Is Nothing Then
  MsgBox "There seems to be nothing.",0,"Create USE"
Else
	
  Select Case e.EntityType
    Case vpNode, vpNodeRef
		Dim n 
		Set n = Document.RootNodes.Add(e)
    Case vpField, vpFieldDecl, vpProtoURL
      MsgBox "Sorry, just a Field: " & e.Name,0,"Create USE"
    Case vpProto, vpExternProto
      MsgBox "Sorry, just a Proto: " & e.Name,0,"Create USE"
    Case vpRoute
      MsgBox "Sorry, just a Route from: " & e.FromField.Name,0,"Create USE"
  End Select
End If
End Sub