BindCommand "PRBox", "Primitive Box", "Primitives|Box..."
Sub PRBox
Set doc = Window.Documents.Active
xx = InputBox("Enter X-Length:","Create Box","1")
If xx = "" Then Exit Sub
On Error Resume Next
yy = InputBox("Enter Y-Height:","Create Box","1")
zz = InputBox("Enter Z-Depth:","Create Box","1")
xx = Replace(xx, ",", ".")
yy = Replace(yy, ",", ".")
zz = Replace(zz, ",", ".")
doc.Selection = "Transform {" + vbCrLf
doc.Selection = "  children	Shape {" + vbCrLf
doc.Selection = "    appearance	Appearance {" + vbCrLf
doc.Selection = "      material	Material {" + vbCrLf
doc.Selection = "			diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "			emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "			ambientIntensity .1" + vbCrLf
doc.Selection = "			shininess .6" + vbCrLf
doc.Selection = "			specularColor 1 1 1" + vbCrLf
doc.Selection = "			transparency 0" + vbCrLf
doc.Selection = "      }" + vbCrLf
doc.Selection = "    }" + vbCrLf
doc.Selection = "    geometry	Box { size " + xx + " " + yy + " " +zz +" }" + vbCrLf
doc.Selection = "  }" + vbCrLf
doc.Selection = "  translation	0 1 0" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub

BindCommand "PRCone", "Primitive Cone", "Primitives|Cone..."
Sub PRCone
Set doc = Window.Documents.Active
rr = InputBox("Enter Bottom-Radius:","Create Cone","1")
If rr = "" Then Exit Sub
On Error Resume Next
hh = InputBox("Enter Height:","Create Cone","5")
hh = Replace(hh, ",", ".")
rr = Replace(rr, ",", ".")
doc.Selection = "Transform {" + vbCrLf
doc.Selection = "  children	Shape {" + vbCrLf
doc.Selection = "    appearance	Appearance {" + vbCrLf
doc.Selection = "      material	Material {" + vbCrLf
doc.Selection = "			diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "			emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "			ambientIntensity .1" + vbCrLf
doc.Selection = "			shininess .6" + vbCrLf
doc.Selection = "			specularColor 1 1 1" + vbCrLf
doc.Selection = "			transparency 0" + vbCrLf
doc.Selection = "      }" + vbCrLf
doc.Selection = "    }" + vbCrLf
doc.Selection = "    geometry	Cone { bottomRadius " + rr + " height " + hh + " }" + vbCrLf
doc.Selection = "  }" + vbCrLf
doc.Selection = "  translation	0 1 0" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub

BindCommand "PRCylinder", "Primitive Cylinder", "Primitives|Cylinder..."
Sub PRCylinder
Set doc = Window.Documents.Active
rr = InputBox("Enter Radius:","Create Cylinder","1")
If rr = "" Then Exit Sub
On Error Resume Next
hh = InputBox("Enter Height:","Create Cylinder","5")
hh = Replace(hh, ",", ".")
rr = Replace(rr, ",", ".")
doc.Selection = "Transform {" + vbCrLf
doc.Selection = "  children	Shape {" + vbCrLf
doc.Selection = "    appearance	Appearance {" + vbCrLf
doc.Selection = "      material	Material {" + vbCrLf
doc.Selection = "			diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "			emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "			ambientIntensity .1" + vbCrLf
doc.Selection = "			shininess .6" + vbCrLf
doc.Selection = "			specularColor 1 1 1" + vbCrLf
doc.Selection = "			transparency 0" + vbCrLf
doc.Selection = "      }" + vbCrLf
doc.Selection = "    }" + vbCrLf
doc.Selection = "    geometry	Cylinder { radius " + rr + " height " + hh + " }" + vbCrLf
doc.Selection = "  }" + vbCrLf
doc.Selection = "  translation	0 1 0" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub

BindCommand "PRElevationGrid", "Primitive ElevationGrid", "Primitives|ElevationGrid..."
Sub PRElevationGrid
Set doc = Window.Documents.Active
ss = ""
xx = InputBox("Enter X-Dimension:","Create ElevationGrid","4")
If xx = "" Then Exit Sub
On Error Resume Next
zz = InputBox("Enter Z-Dimension:","Create ElevationGrid","4")
xs = InputBox("Enter X-Spacing:","Create ElevationGrid","10")
zs = InputBox("Enter Z-Spacing:","Create ElevationGrid","10")
ha = InputBox("Enter Max Height:","Create ElevationGrid","5")
tx = ((xx-1)*xs)/2
tz = ((zz-1)*zs)/2
tx = CStr(tx)
tz = CStr(tz)
tx = Replace(tx, ",", ".")
tz = Replace(tz, ",", ".")
xx = Replace(xx, ",", ".")
zz = Replace(zz, ",", ".")
xs = Replace(xs, ",", ".")
zs = Replace(zs, ",", ".")
for cc = 1 to xx
	for tt = 1 to zz
		Randomize
		mm = int((Rnd(ha))*ha)
		mm = CStr(mm)
		ss = ss + " " + mm 
	next
ss = ss + ","
next
doc.Selection = "Transform {" + vbCrLf
doc.Selection = "  children	Shape {" + vbCrLf
doc.Selection = "    appearance	Appearance {" + vbCrLf
doc.Selection = "      material	Material {" + vbCrLf
doc.Selection = "			diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "			emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "			ambientIntensity .1" + vbCrLf
doc.Selection = "			shininess .6" + vbCrLf
doc.Selection = "			specularColor 1 1 1" + vbCrLf
doc.Selection = "			transparency 0" + vbCrLf
doc.Selection = "      }" + vbCrLf
doc.Selection = "    }" + vbCrLf
doc.Selection = "    geometry	ElevationGrid {" + vbCrLf
doc.Selection = "      xDimension	" + xx + vbCrLf
doc.Selection = "      zDimension	" + zz + vbCrLf
doc.Selection = "      xSpacing	" + xs + vbCrLf
doc.Selection = "      zSpacing	" + zs + vbCrLf
doc.Selection = "      height	[ " + ss + " ]" + vbCrLf
doc.Selection = "      solid	FALSE" + vbCrLf
doc.Selection = "      creaseAngle	3" + vbCrLf
doc.Selection = "    }" + vbCrLf
doc.Selection = "  }" + vbCrLf
doc.Selection = "  translation	-" + tx +" 0 -" + tz + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub

BindCommand "PRLineset", "Primitive Lineset", "Primitives|Lineset..."
Sub PRLineset
Set doc = Window.Documents.Active
xx = InputBox("Enter X-Length:","Create Lineset","1")
If xx = "" Then Exit Sub
On Error Resume Next
zz = InputBox("Enter Z-Depth:","Create Lineset","1")
rr = InputBox("Enter Rotation:","Create Lineset","1.57079")
xx = xx/2
zz = zz/2
xx = CStr(xx)
zz = CStr(zz)
xx = Replace(xx, ",", ".")
rr = Replace(rr, ",", ".")
zz = Replace(zz, ",", ".")
doc.Selection = "Transform {" + vbCrLf
doc.Selection = "  children	Shape {" + vbCrLf
doc.Selection = "    appearance	Appearance {" + vbCrLf
doc.Selection = "      material	Material {" + vbCrLf
doc.Selection = "			diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "			emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "			ambientIntensity .1" + vbCrLf
doc.Selection = "			shininess .6" + vbCrLf
doc.Selection = "			specularColor 1 1 1" + vbCrLf
doc.Selection = "			transparency 0" + vbCrLf
doc.Selection = "      }" + vbCrLf
doc.Selection = "    }" + vbCrLf
doc.Selection = "    geometry	IndexedLineSet {" + vbCrLf
doc.Selection = "    	coord	Coordinate {" + vbCrLf
doc.Selection = "    	point	[ -" + xx + " -" + zz + " 0," + vbCrLf
doc.Selection = "    	-" + xx + " " + zz + " 0," + vbCrLf
doc.Selection = "    	" + xx + " " + zz +" 0," + vbCrLf
doc.Selection = "    	" + xx + " -" + zz + " 0 ]" + vbCrLf
doc.Selection = "    	}" + vbCrLf
doc.Selection = "    	coordIndex	[ 0, 1, 2, 3, 0 ]" + vbCrLf
doc.Selection = "    	solid	FALSE" + vbCrLf
doc.Selection = "    	normalIndex	[  ]" + vbCrLf
doc.Selection = "    	texCoordIndex	[  ]" + vbCrLf
doc.Selection = " 	}" + vbCrLf
doc.Selection = "	}" + vbCrLf
doc.Selection = "	translation	0 1 0" + vbCrLf
doc.Selection = "	rotation	-1 0 0  " + rr + vbCrLf
doc.Selection = "	scale	1 1 1" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub


BindCommand "PRPlane", "Primitive Plane", "Primitives|Plane..."
Sub PRPlane
Set doc = Window.Documents.Active
xx = InputBox("Enter X-Length:","Create Plane","1")
If xx = "" Then Exit Sub
On Error Resume Next
zz = InputBox("Enter Z-Depth:","Create Plane","1")
rr = InputBox("Enter Rotation:","Create Plane","1.57079")
xx = xx/2
zz = zz/2
xx = CStr(xx)
zz = CStr(zz)
xx = Replace(xx, ",", ".")
rr = Replace(rr, ",", ".")
zz = Replace(zz, ",", ".")
doc.Selection = "Transform {" + vbCrLf
doc.Selection = "  children	Shape {" + vbCrLf
doc.Selection = "    appearance	Appearance {" + vbCrLf
doc.Selection = "      material	Material {" + vbCrLf
doc.Selection = "			diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "			emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "			ambientIntensity .1" + vbCrLf
doc.Selection = "			shininess .6" + vbCrLf
doc.Selection = "			specularColor 1 1 1" + vbCrLf
doc.Selection = "			transparency 0" + vbCrLf
doc.Selection = "      }" + vbCrLf
doc.Selection = "    }" + vbCrLf
doc.Selection = "    geometry	IndexedFaceSet {" + vbCrLf
doc.Selection = "    	coord	Coordinate {" + vbCrLf
doc.Selection = "    	point	[ -" + xx + " -" + zz + " 0," + vbCrLf
doc.Selection = "    	-" + xx + " " + zz + " 0," + vbCrLf
doc.Selection = "    	" + xx + " " + zz +" 0," + vbCrLf
doc.Selection = "    	" + xx + " -" + zz + " 0 ]" + vbCrLf
doc.Selection = "    	}" + vbCrLf
doc.Selection = "    	coordIndex	[ 0, 1, 2, 3, -1 ]" + vbCrLf
doc.Selection = "    	solid	FALSE" + vbCrLf
doc.Selection = "    	normalIndex	[  ]" + vbCrLf
doc.Selection = "    	texCoordIndex	[  ]" + vbCrLf
doc.Selection = " 	}" + vbCrLf
doc.Selection = "	}" + vbCrLf
doc.Selection = "	translation	0 1 0" + vbCrLf
doc.Selection = "	rotation	-1 0 0  " + rr + vbCrLf
doc.Selection = "	scale	1 1 1" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub

BindCommand "PRSphere", "Primitive Sphere", "Primitives|Sphere..."
Sub PRSphere
Set doc = Window.Documents.Active
rr = InputBox("Enter Radius:","Create Sphere","1")
If rr = "" Then Exit Sub
On Error Resume Next
rr = Replace(rr, ",", ".")
doc.Selection = "Transform {" + vbCrLf
doc.Selection = "  children	Shape {" + vbCrLf
doc.Selection = "    appearance	Appearance {" + vbCrLf
doc.Selection = "		material	Material {" + vbCrLf
doc.Selection = "			diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "			emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "			ambientIntensity .1" + vbCrLf
doc.Selection = "			shininess .6" + vbCrLf
doc.Selection = "			specularColor 1 1 1" + vbCrLf
doc.Selection = "			transparency 0" + vbCrLf
doc.Selection = "      }" + vbCrLf
doc.Selection = "    }" + vbCrLf
doc.Selection = "    geometry	Sphere { radius " + rr + " }" + vbCrLf
doc.Selection = "  }" + vbCrLf
doc.Selection = "  translation	0 1 0" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub

BindCommand "PRText", "Primitive Text", "Primitives|Text..."
Sub PRText
Set doc = Window.Documents.Active
tt = InputBox("Enter Textstring:","Create Text")
If tt = "" Then Exit Sub
On Error Resume Next
ff = InputBox("Enter Fontname (Serif, Sanserif, Arial ...):","Create Text","Sanserif")
fs = InputBox("Enter Fontsize:","Create Text","1")
fy = InputBox("Enter Fontstyle (PLAIN, ITALIC, BOLD, BOLDITALIC:","Create Text","PLAIN")
fs = Replace(fs, ",", ".")
doc.Selection = "Transform {" + vbCrLf
doc.Selection = "  children	Shape {" + vbCrLf
doc.Selection = "    appearance	Appearance {" + vbCrLf
doc.Selection = "		material	Material {" + vbCrLf
doc.Selection = "			diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "			emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "			ambientIntensity .1" + vbCrLf
doc.Selection = "			shininess .6" + vbCrLf
doc.Selection = "			specularColor 1 1 1" + vbCrLf
doc.Selection = "			transparency 0" + vbCrLf
doc.Selection = "      }" + vbCrLf
doc.Selection = "    }" + vbCrLf
doc.Selection = "    geometry	Text {" + vbCrLf
doc.Selection = "      fontStyle	FontStyle {" + vbCrLf
doc.Selection = "			size " + fs + vbCrLf
doc.Selection = "			style """ + fy + """" + vbCrLf
doc.Selection = "			family """ + ff + """" + vbCrLf
doc.Selection = "      }" + vbCrLf
doc.Selection = "      string	""" + tt + """" + vbCrLf
doc.Selection = "    }" + vbCrLf
doc.Selection = "  }" + vbCrLf
doc.Selection = "  translation	-1 0 -1" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub

BindCommand "EXDoor", "Door", "Extended|Door..."
Sub EXDoor
Set doc = Window.Documents.Active
Window.StatusText "Don't forget to insert Externprots for Extended Primitives", &h0040FF
dd = InputBox("Enter Dimensions (Width Height Depth):","Create Door",".85 2.05 .05")
If dd = "" Then Exit Sub
On Error Resume Next
pp = InputBox("Enter Direction (Push or Pull):","Create Door","Push")
rr = InputBox("Enter Rotation Side (Left or Right):","Create Door","Right")
bb = InputBox("Enter Behavior (Proximity or Touch):","Create Door","Proximity")
dd = Replace(dd, ",", ".")
pp = Replace(pp, ",", ".")
rr = Replace(rr, ",", ".")
bb = Replace(bb, ",", ".")
doc.Selection = "Door {" + vbCrLf
doc.Selection = "	size " + dd + vbCrLf
doc.Selection = "	direction """ + pp + """" + vbCrLf
doc.Selection = "	side """ + rr + """" + vbCrLf
doc.Selection = "	sensorType """ + bb + """" + vbCrLf
doc.Selection = "	proxiSize 4 4 8" + vbCrLf
doc.Selection = "	openingDuration .5" + vbCrLf
doc.Selection = "	closingDuration 1" + vbCrLf
doc.Selection = "	diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "	emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "	specularColor 1 1 1" + vbCrLf
doc.Selection = "	ambientIntensity .1" + vbCrLf
doc.Selection = "	shininess .1" + vbCrLf
doc.Selection = "	transparency 0" + vbCrLf
doc.Selection = "	textureUrl ""maps/door.jpg"" " + vbCrLf
doc.Selection = "	textureScale 1 1" + vbCrLf
doc.Selection = "	translation 0 0 0" + vbCrLf
doc.Selection = "	rotation 0 0 0 0" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub

BindCommand "EXNGon", "NGon", "Extended|NGon..."
Sub EXNGon
Set doc = Window.Documents.Active
Window.StatusText "Don't forget to insert Externprots for Extended Primitives", &h0040FF
ss = InputBox("Enter Number of Sides:","Create NGon","5")
If ss = "" Then Exit Sub
On Error Resume Next
hh = InputBox("Enter Height:","Create NGon","5")
rr = InputBox("Enter Radius:","Create NGon","1")
tt = InputBox("Enter Topscale :","Create NGon",".5 .5")
bb = InputBox("Enter Segments:","Create NGon","1 1")
rr = Replace(rr, ",", ".")
tt = Replace(tt, ",", ".")
bb = Replace(bb, ",", ".")
ss = Replace(ss, ",", ".")
doc.Selection = "Transform {" + vbCrLf
doc.Selection = "	translation 0 0 0" + vbCrLf
doc.Selection = "	children [ Shape {" + vbCrLf
doc.Selection = "	appearance Appearance {" + vbCrLf
doc.Selection = "		material Material {" + vbCrLf
doc.Selection = "			diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "			emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "			ambientIntensity .1" + vbCrLf
doc.Selection = "			shininess .6" + vbCrLf
doc.Selection = "			specularColor 1 1 1" + vbCrLf
doc.Selection = "			transparency 0" + vbCrLf
doc.Selection = "		}" + vbCrLf
doc.Selection = "	}" + vbCrLf
doc.Selection = "	geometry NGon {" + vbCrLf
doc.Selection = "		creaseAngle 1" + vbCrLf
doc.Selection = "		sides " + ss + vbCrLf
doc.Selection = "		height " + hh + vbCrLf
doc.Selection = "		radius " + rr + vbCrLf
doc.Selection = "		topScale " + tt + vbCrLf
doc.Selection = "		bottomScale " + bb + vbCrLf
doc.Selection = "	}" + vbCrLf
doc.Selection = "	}" + vbCrLf
doc.Selection = "	]" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub

BindCommand "EXStairs", "Stairs", "Extended|Stairs..."
Sub EXStairs
Set doc = Window.Documents.Active
Window.StatusText "Don't forget to insert Externprots for Extended Primitives", &h0040FF
ss = InputBox("Enter Number of Steps:","Create Stairs","10")
If ss = "" Then Exit Sub
On Error Resume Next
oo = InputBox("Enter Overlap (0 to 1, 0 - no overlap, 1 - full overlap :","Create Stairs","0")
ii = InputBox("Enter Size (Width Height Depth):","Create Stairs","1 .2 .5")
mm = InputBox("Material Name:","Create Stairs","Stairs01")
ss = Replace(ss, ",", ".")
oo = Replace(oo, ",", ".")
ii = Replace(ii, ",", ".")
mm = Replace(mm, ",", ".")
doc.Selection = "Stairs {" + vbCrLf
doc.Selection = "	steps " + ss + vbCrLf
doc.Selection = "	size " + ii + vbCrLf
doc.Selection = "	overlap " + oo + vbCrLf
doc.Selection = "	texName """ + mm + """" + vbCrLf
doc.Selection = "	texUrl ""maps/stair.jpg"" " + vbCrLf
doc.Selection = "	texScale 1 1" + vbCrLf
doc.Selection = "	diffuse .6 .6 .6" + vbCrLf
doc.Selection = "	emissive .1 .1 .1" + vbCrLf
doc.Selection = "	specular 1 1 1" + vbCrLf
doc.Selection = "	shin .1" + vbCrLf
doc.Selection = "	ambient	.1" + vbCrLf
doc.Selection = "	transp 0" + vbCrLf
doc.Selection = "	transl 0 0 0" + vbCrLf
doc.Selection = "	rotat -1 0 0 1.57079" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub

BindCommand "EXTorus", "Torus", "Extended|Torus..."
Sub EXTorus
Set doc = Window.Documents.Active
Window.StatusText "Don't forget to insert Externprots for Extended Primitives", &h0040FF
rr = InputBox("Enter Radius:","Create Torus","1")
If rr = "" Then Exit Sub
On Error Resume Next
tt = InputBox("Enter Thickness :","Create Torus",".5")
ss = InputBox("Enter SpineSegments:","Create Torus","24")
ii = InputBox("Enter RimSegments:","Create Torus","12")
rr = Replace(rr, ",", ".")
tt = Replace(tt, ",", ".")
ss = Replace(ss, ",", ".")
ii = Replace(ii, ",", ".")
doc.Selection = "Transform {" + vbCrLf
doc.Selection = "	translation 0 0 0" + vbCrLf
doc.Selection = "	children [ Shape {" + vbCrLf
doc.Selection = "	appearance Appearance {" + vbCrLf
doc.Selection = "		material Material {" + vbCrLf
doc.Selection = "			diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "			emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "			ambientIntensity .1" + vbCrLf
doc.Selection = "			shininess .6" + vbCrLf
doc.Selection = "			specularColor 1 1 1" + vbCrLf
doc.Selection = "			transparency 0" + vbCrLf
doc.Selection = "		}" + vbCrLf
doc.Selection = "	}" + vbCrLf
doc.Selection = "	geometry Torus {" + vbCrLf
doc.Selection = "		creaseAngle 1" + vbCrLf
doc.Selection = "		radius " + rr + vbCrLf
doc.Selection = "		thickness " + tt + vbCrLf
doc.Selection = "		rimSegments " + ii + vbCrLf
doc.Selection = "		spineSegments " + ss + vbCrLf
doc.Selection = "	}" + vbCrLf
doc.Selection = "	}" + vbCrLf
doc.Selection = "	]" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub

BindCommand "EXPyra", "TruncatedPyramid", "Extended|Truncated Pyramid..."
Sub EXPyra
Set doc = Window.Documents.Active
Window.StatusText "Don't forget to insert Externprots for Extended Primitives", &h0040FF
bb = InputBox("Enter Dimensions bottom (Width Depth):","Create Truncated Pyramid","2 2")
If bb = "" Then Exit Sub
On Error Resume Next
tt = InputBox("Enter Dimensions top (Width Depth):","Create Truncated Pyramid","1 1")
hh = InputBox("Enter Height:","Create Truncated Pyramid","1")
bb = Replace(bb, ",", ".")
tt = Replace(tt, ",", ".")
hh = Replace(hh, ",", ".")
doc.Selection = "TruncatedPyramid {" + vbCrLf
doc.Selection = "	bottomSize " + bb + vbCrLf
doc.Selection = "	topSize " + tt + vbCrLf
doc.Selection = "	height " + hh + vbCrLf
doc.Selection = "	diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "	emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "	specularColor 1 1 1" + vbCrLf
doc.Selection = "	ambientIntensity .1" + vbCrLf
doc.Selection = "	shininess .1" + vbCrLf
doc.Selection = "	transparency 0" + vbCrLf
doc.Selection = "	textureUrl ""maps/roof.jpg"" " + vbCrLf
doc.Selection = "	textureScale 1 1" + vbCrLf
doc.Selection = "	translation 0 0 0" + vbCrLf
doc.Selection = "	rotation 0 0 0 0" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub

BindCommand "EXTube", "Tube", "Extended|Tube..."
Sub EXTube
Set doc = Window.Documents.Active
Window.StatusText "Don't forget to insert Externprots for Extended Primitives", &h0040FF
rr = InputBox("Enter Radius:","Create Tube","1")
If rr = "" Then Exit Sub
On Error Resume Next
tt = InputBox("Enter Thickness :","Create Tube",".2")
hh = InputBox("Enter Height:","Create Tube","5")
ss = InputBox("Enter Segments:","Create Tube","12")
rr = Replace(rr, ",", ".")
tt = Replace(tt, ",", ".")
hh = Replace(hh, ",", ".")
ss = Replace(ss, ",", ".")
doc.Selection = "Transform {" + vbCrLf
doc.Selection = "	translation 0 0 0" + vbCrLf
doc.Selection = "	children [ Shape {" + vbCrLf
doc.Selection = "	appearance Appearance {" + vbCrLf
doc.Selection = "		material Material {" + vbCrLf
doc.Selection = "			diffuseColor .6 .6 .6" + vbCrLf
doc.Selection = "			emissiveColor .1 .1 .1" + vbCrLf
doc.Selection = "			ambientIntensity .1" + vbCrLf
doc.Selection = "			shininess .6" + vbCrLf
doc.Selection = "			specularColor 1 1 1" + vbCrLf
doc.Selection = "			transparency 0" + vbCrLf
doc.Selection = "		}" + vbCrLf
doc.Selection = "	}" + vbCrLf
doc.Selection = "	geometry Tube {" + vbCrLf
doc.Selection = "		creaseAngle 1" + vbCrLf
doc.Selection = "		radius " + rr + vbCrLf
doc.Selection = "		thickness " + tt + vbCrLf
doc.Selection = "		height " + hh + vbCrLf
doc.Selection = "		segments " + ss + vbCrLf
doc.Selection = "	}" + vbCrLf
doc.Selection = "	}" + vbCrLf
doc.Selection = "	]" + vbCrLf
doc.Selection = "}" + vbCrLf
doc.Saved = False
End Sub